
void writeInitValues()
{
  if (iRomversion != ROMVERSION)
  {
    String updates = "update from " + String(iRomversion) + " ";
    eeprom_Function = 35;
    writeEEPROM(); // Schreibe aktuelle Version
    delay(10);
    if (iRomversion < 10008)
    { // initale Werte fuer aeltere Versionen
      eeprom_Function = 34;
      writeEEPROM();
      delay(10);
      updates = updates + "1.0.8,";
    }
    if (iRomversion < 10009)
    { // initale Werte fuer aeltere Versionen
      eeprom_Function = 36;
      writeEEPROM();
      delay(10);
      eeprom_Function = 37;
      writeEEPROM();
      delay(10);
      eeprom_Function = 38;
      writeEEPROM();
      delay(10);
      eeprom_Function = 39;
      writeEEPROM();
      delay(10);
      updates = updates + "1.0.9,";
    }
    if (iRomversion < 10101)
    { // initale Werte fuer aeltere Versionen
      eeprom_Function = 40;
      writeEEPROM();
      delay(10);
      eeprom_Function = 41;
      writeEEPROM();
      delay(10);
      updates = updates + "1.1.1,";
    }
    if (iRomversion < 10104)
    { // initale Werte fuer aeltere Versionen
      eeprom_Function = 42;
      writeEEPROM();
      delay(10);
      updates = updates + "1.1.4,";
    }
    if (iRomversion < 10105)
    { // initale Werte fuer aeltere Versionen
      eeprom_Function = 43;
      writeEEPROM();
      delay(10);
      eeprom_Function = 44;
      writeEEPROM();
      delay(10);
      eeprom_Function = 45;
      writeEEPROM();
      delay(10);
      updates = updates + "1.1.5,";
    }
    build_wwwStatus2(updates);
  }
}
void readFirstStart()
{
  first_Startup = eeprom_read_string(550, 1).toInt();
  delay(100);
  //Serial.println("FIRST_STARTUP : " + String(first_Startup));
}
void readVersion()
{
  iRomversion = eeprom_read_string(674, 6).toInt();
  if (iRomversion < 0 || iRomversion > 90000)
  {
    iRomversion = 0;
  }
  delay(100);
  //Serial.println("Version : " + String(iRomversion));
}
void readWifi()
{
  wifi_SSID = eeprom_read_string(0, 32);
  wifi_PWD = eeprom_read_string(32, 64);
}
void writeWifi()
{
  eeprom_Function = 20;
  writeEEPROM();
  eeprom_Function = 21;
  writeEEPROM();
}
void deleteEEPROM()
{
  for (int i = 0; i < 1000; i++)
  {
    EEPROM.write(i, 0);
  }
  EEPROM.commit();
  delay(1000);
}
void readEEPROM()
{
  String tmpValue = "";
  // Read Wifi-Data
  wifi_SSID = eeprom_read_string(0, 32);
  wifi_PWD = eeprom_read_string(32, 64);
  // Read the ioBroker Values
  eeprom_read_string(100, 16).toCharArray(host_ioBrokerIP, 16);
  ;
  host_ioBrokerPORT = eeprom_read_string(120, 5).toInt();
  IOB_active = eeprom_read_string(128, 1).toInt();
  if (IOB_active < 0 || IOB_active > 1)
  {
    IOB_active = 0;
  }
  DeltaSendState = eeprom_read_string(130, 8).toInt();
  if (DeltaSendState < 60000)
  {
    DeltaSendState = 60000;
  }
  eeprom_read_string(150, 80).toCharArray(IOB_Datapoint_Path, 80);
  eeprom_read_string(250, 80).toCharArray(IOB_Datapoint_Sub, 80);
  eeprom_read_string(350, 80).toCharArray(IOB_Datapoint_State, 80);
  eeprom_read_string(450, 80).toCharArray(IOB_Datapoint_Message, 80);
  // Read the CCU CuxD Values
  eeprom_read_string(600, 38).toCharArray(CCU_CuxDAdress, 38);
  CCU_CuxD = eeprom_read_string(555, 2).toInt();
  if (CCU_CuxD < 0 || CCU_CuxD > 1)
  {
    CCU_CuxD = 0;
  }
  eeprom_read_string(560, 16).toCharArray(host_CCUIP, 16);
  //read the general Command States
  stateONPowerON = eeprom_read_string(97, 2).toInt();
  if (stateONPowerON < 0 || stateONPowerON > 2)
  {
    stateONPowerON = 0;
  }
  enableReconnect = eeprom_read_string(140, 2).toInt();
  if (enableReconnect < 0 || enableReconnect > 1)
  {
    enableReconnect = 1;
  }
  DeltaKeepWIFIAlive = eeprom_read_string(142, 6).toInt() * 1000;
  if (DeltaKeepWIFIAlive < 60000)
  {
    DeltaKeepWIFIAlive = 60000;
  }
  HardwareDogOnTime = eeprom_read_string(640, 6).toInt() * 1000;
  if (HardwareDogOnTime < 60000)
  {
    HardwareDogOnTime = 60000;
  }
  HardwareDogOffTime = eeprom_read_string(646, 6).toInt() * 1000;
  if (HardwareDogOffTime < 10000)
  {
    HardwareDogOffTime = 10000;
  }
  iNTPServer = eeprom_read_string(652, 2).toInt();
  if (iNTPServer < 0 || iNTPServer > 1)
  {
    iNTPServer = 0;
  }
  iDevname = eeprom_read_string(654, 20);
  if (iDevname.length() < 1)
  {
    iDevname = F("ESP8266 Wall Plug OBI");
  }
  tmpValue = eeprom_read_string(680, 16);
  if (tmpValue.length() < 1)
  {
    tmpValue = F("192.168.0.77");
  }
  fIPown.fromString(tmpValue);
  tmpValue = eeprom_read_string(700, 16);
  if (tmpValue.length() < 1)
  {
    tmpValue = F("192.168.0.1");
  }
  fIPgateway.fromString(tmpValue);
  tmpValue = eeprom_read_string(720, 16);
  if (tmpValue.length() < 1)
  {
    tmpValue = F("255.255.255.0");
  }
  fIPsubnet.fromString(tmpValue);
  fIPstatus = eeprom_read_string(737, 2).toInt();
  if (fIPstatus < 0 || fIPstatus > 1)
  {
    fIPstatus = 0;
  }
  fcpufreq = eeprom_read_string(739, 3).toInt();
  if ((fcpufreq != 80) && (fcpufreq != 160))
  {
    fcpufreq = 80;
  }
  ajaxon = eeprom_read_string(742, 2).toInt();
  if (ajaxon < 0 || ajaxon > 1)
  {
    ajaxon = 1;
  }
  pingTest = eeprom_read_string(744, 2).toInt();
  if (pingTest < 0 || pingTest > 1)
  {
    pingTest = 1;
  }
  MQTT_active = eeprom_read_string(746, 2).toInt();
  if (MQTT_active < 0 || MQTT_active > 1)
  {
    MQTT_active = 0;
  }
  eeprom_read_string(750, 16).toCharArray(host_MQTT, 16);
  eeprom_read_string(770, 80).toCharArray(path_MQTT, 80);
}
void writeEEPROM()
{
  //  eeprom_Function is needed to write to the correct address in EEPROM
  /*
 * ##### USED EEPROM ADRESSES #####
 * 0  - 31    : SSID /20
 * 32 - 95    : SSID Password /21
 * 97 - 98    : Relay State on PowerON /7
 * 100 - 116  : ioBroker IP /1 
 * 120 - 125  : ioBroker PORT /2
 * 128 - 129  : ioBroker active /13
 * 130 - 138  : ioBroker SendState /8
 * 140 - 141  : Wifi.reconnect enabled /9 
 * 142 - 147  : Wifi.reconnect Time /30 DeltaKeepWIFIAlive
 * 150 - 230  : ioBroker Datapoint /3
 * 250 - 330  : ioBroker Datapoint Subpath /4
 * 350 - 430  : ioBroker Datapoint State Name /5
 * 450 - 530  : ioBroker Datapoint Message Name /6
 * 550 - 551  : First Startup /99
 * 555 - 556  : CCU CUxD Enabled /10
 * 560 - 598  : host_CCUIP Adress /12
 * 600 - 637  : CCU CUxD Adress /11
 * 640 - 645  : HardwareWatchOnTime /31
 * 646 - 651  : HardwareWatchOffTime /32
 * 652 - 653  : NTP-Server (0=default/1=Router) /33
 * 654 - 673  : Devname /34
 * 674 - 679  : Versionsnummer /35
 * 680 - 696  : Fix-IP /36
 * 700 - 716  : Fix-Gateway /37
 * 720 - 736  : Fix-Subnet /38
 * 737 - 738  : Fix-IP-ON /39 (0=off/1=on)
 * 739 - 741  : CPU-FREQ /40 (80/160)
 * 742 - 743  : AJAXON /41 (0=off/1=on)
 * 744 - 745  : PING /42 (0=off/1=on)
 * 746 - 747  : MQTT active /43
 * 750 - 766  : MQTT IP /44
 * 770 - 850  : MQTT PATH /45
 */
  String tmpValue = "";
  String tSt = "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
  bool found = false;
  switch (eeprom_Function)
  {
  case 1: //IOB IP
    tmpValue = String(host_ioBrokerIP) + tSt;
    for (int i = 0; i < 16; i++)
    {
      EEPROM.write(100 + i, tmpValue[i]);
    }
    //Serial.println("ioBroker IP written to EEPROM");
    found = true;
    break;
  case 2: //IOB PORT
    tmpValue = String(host_ioBrokerPORT) + tSt;
    for (int i = 0; i < 5; i++)
    {
      EEPROM.write(120 + i, tmpValue[i]);
    }
    //Serial.println("ioBroker PORT written to EEPROM");
    found = true;
    break;
  case 3: //IOB Path
    tmpValue = String(IOB_Datapoint_Path) + tSt;
    for (int i = 0; i < 80; i++)
    {
      EEPROM.write(150 + i, tmpValue[i]);
    }
    //Serial.println("ioBroker Datapoint Name written to EEPROM");
    found = true;
    break;
  case 4: //IOB SUB
    tmpValue = String(IOB_Datapoint_Sub) + tSt;
    for (int i = 0; i < 80; i++)
    {
      EEPROM.write(250 + i, tmpValue[i]);
    }
    //Serial.println("ioBroker Datapoint Path written to EEPROM");
    found = true;
    break;
  case 5: //IOB State
    tmpValue = String(IOB_Datapoint_State) + tSt;
    for (int i = 0; i < 80; i++)
    {
      EEPROM.write(350 + i, tmpValue[i]);
    }
    //Serial.println("ioBroker State Name written to EEPROM");
    found = true;
    break;
  case 6: //IOB Message
    tmpValue = String(IOB_Datapoint_Message) + tSt;
    for (int i = 0; i < 80; i++)
    {
      EEPROM.write(450 + i, tmpValue[i]);
    }
    //Serial.println("ioBroker Message Name written to EEPROM");
    found = true;
    break;
  case 7: //Relay PowerON State
    tmpValue = String(stateONPowerON) + tSt;
    for (int i = 0; i < 2; i++)
    {
      EEPROM.write(97 + i, tmpValue[i]);
    }
    //Serial.println("PowerOn State written to EEPROM");
    found = true;
    break;
  case 8: //IOB_StateMessage_Time
    tmpValue = String(DeltaSendState) + tSt;
    if (DeltaSendState < 60000)
    {
      DeltaSendState = 60000;
    }
    for (int i = 0; i < 8; i++)
    {
      EEPROM.write(130 + i, tmpValue[i]);
    }
    //Serial.println("State Message Time written to EEPROM");
    found = true;
    break;
  case 9: //enable Wifi.reconnect
    tmpValue = String(enableReconnect) + tSt;
    for (int i = 0; i < 2; i++)
    {
      EEPROM.write(140 + i, tmpValue[i]);
    }
    //Serial.println("Wifi.Reconncet enabled is written to EEPROM");
    found = true;
    break;
  case 10: //CuxD_enabled
    tmpValue = String(CCU_CuxD) + tSt;
    for (int i = 0; i < 1; i++)
    {
      EEPROM.write(555 + i, tmpValue[i]);
    }
    //Serial.println("CuxD Enabled written to EEPROM");
    found = true;
    break;
  case 11: //CuxD Adress
    tmpValue = String(CCU_CuxDAdress) + tSt;
    for (int i = 0; i < 38; i++)
    {
      EEPROM.write(600 + i, tmpValue[i]);
    }
    //Serial.println("CCU CuxD Adress written to EEPROM");
    found = true;
    break;
  case 12: //CCU IP Adress
    tmpValue = String(host_CCUIP) + tSt;
    for (int i = 0; i < 16; i++)
    {
      EEPROM.write(560 + i, tmpValue[i]);
    }
    //Serial.println("CCU IP Adress written to EEPROM");
    found = true;
    break;
  case 13: //IOB active
    tmpValue = String(IOB_active) + tSt;
    for (int i = 0; i < 1; i++)
    {
      EEPROM.write(128 + i, tmpValue[i]);
    }
    //Serial.println("ioBroker active  written to EEPROM");
    found = true;
    break;
  case 20: //wifi_SSID
    tmpValue = String(wifi_SSID) + tSt;
    for (int i = 0; i < 32; i++)
    {
      EEPROM.write(0 + i, tmpValue[i]);
    }
    //Serial.println("SSID written to EEPROM");
    found = true;
    break;
  case 21: //wifi_PWD
    tmpValue = String(wifi_PWD) + tSt + tSt + tSt;
    for (int i = 0; i < 64; i++)
    {
      EEPROM.write(32 + i, tmpValue[i]);
    }
    //Serial.println("SSID written to EEPROM");
    found = true;
    break;
  case 30: //Wifi-Connect-Time
    tmpValue = String(DeltaKeepWIFIAlive / 1000) + tSt;
    for (int i = 0; i < 6; i++)
    {
      EEPROM.write(142 + i, tmpValue[i]);
    }
    //Serial.println("DeltaKeepWIFIAlive active  written to EEPROM");
    found = true;
    break;
  case 31: //HardwareDogOnTime
    tmpValue = String(HardwareDogOnTime / 1000) + tSt;
    for (int i = 0; i < 6; i++)
    {
      EEPROM.write(640 + i, tmpValue[i]);
    }
    //Serial.println("HardwareDogOnTime active  written to EEPROM");
    found = true;
    break;
  case 32: //HardwareDogOffTime
    tmpValue = String(HardwareDogOffTime / 1000) + tSt;
    for (int i = 0; i < 6; i++)
    {
      EEPROM.write(646 + i, tmpValue[i]);
    }
    //Serial.println("HardwareDogOffTime active  written to EEPROM");
    found = true;
    break;
  case 33: //NTPServer
    tmpValue = String(iNTPServer) + tSt;
    for (int i = 0; i < 2; i++)
    {
      EEPROM.write(652 + i, tmpValue[i]);
    }
    //Serial.println("NTPServer active  written to EEPROM");
    found = true;
    break;
  case 34: //DevName
    tmpValue = String(iDevname) + tSt;
    for (int i = 0; i < 20; i++)
    {
      EEPROM.write(654 + i, tmpValue[i]);
    }
    //Serial.println("Devname written to EEPROM");
    found = true;
    break;
  case 35: //Version
    tmpValue = String(ROMVERSION) + tSt;
    for (int i = 0; i < 6; i++)
    {
      EEPROM.write(674 + i, tmpValue[i]);
    }
    //Serial.println("Romversion written to EEPROM");
    found = true;
    break;
  case 36: //fix-IP
    tmpValue = fIPown.toString() + tSt;
    for (int i = 0; i < 16; i++)
    {
      EEPROM.write(680 + i, tmpValue[i]);
    }
    //Serial.println("FIXE IP written to EEPROM");
    found = true;
    break;
  case 37: //fix-Gateway
    tmpValue = fIPgateway.toString() + tSt;
    for (int i = 0; i < 16; i++)
    {
      EEPROM.write(700 + i, tmpValue[i]);
    }
    //Serial.println("FIXE IP written to EEPROM");
    found = true;
    break;
  case 38: //fix-Subnet
    tmpValue = fIPsubnet.toString() + tSt;
    for (int i = 0; i < 16; i++)
    {
      EEPROM.write(720 + i, tmpValue[i]);
    }
    //Serial.println("FIXE IP written to EEPROM");
    found = true;
    break;
  case 39: //fix-IP
    tmpValue = String(fIPstatus) + tSt;
    for (int i = 0; i < 2; i++)
    {
      EEPROM.write(737 + i, tmpValue[i]);
    }
    //Serial.println("FIXE IP written to EEPROM");
    found = true;
    break;
  case 40: //CPUFREQ
    tmpValue = String(fcpufreq) + tSt;
    for (int i = 0; i < 3; i++)
    {
      EEPROM.write(739 + i, tmpValue[i]);
    }
    //Serial.println("CPUFREQ written to EEPROM");
    found = true;
    break;
  case 41: //AJAXON
    tmpValue = String(ajaxon) + tSt;
    for (int i = 0; i < 2; i++)
    {
      EEPROM.write(742 + i, tmpValue[i]);
    }
    //Serial.println("AJAXON written to EEPROM");
    found = true;
    break;
  case 42: //PING
    tmpValue = String(pingTest) + tSt;
    for (int i = 0; i < 2; i++)
    {
      EEPROM.write(744 + i, tmpValue[i]);
    }
    //Serial.println("PING written to EEPROM");
    found = true;
    break;
  case 43: //MQTT Active
    tmpValue = String(MQTT_active) + tSt;
    for (int i = 0; i < 2; i++)
    {
      EEPROM.write(746 + i, tmpValue[i]);
    }
    //Serial.println("MQTT Active written to EEPROM");
    found = true;
    break;
  case 44: //MQTT IP
    tmpValue = String(host_MQTT) + tSt;
    for (int i = 0; i < 16; i++)
    {
      EEPROM.write(750 + i, tmpValue[i]);
    }
    //Serial.println("MQTT_host written to EEPROM");
    found = true;
    break;
  case 45: //MQTT PATH
    tmpValue = String(path_MQTT) + tSt;
    for (int i = 0; i < 80; i++)
    {
      EEPROM.write(770 + i, tmpValue[i]);
    }
    //Serial.println("PATH written to EEPROM");
    found = true;
    break;
  case 99: //First_Startup
    tmpValue = String(first_Startup) + tSt;
    for (int i = 0; i < 1; i++)
    {
      EEPROM.write(550 + i, tmpValue[i]);
    }
    //Serial.println("STARTUP written to EEPROM");
    found = true;
    break;
  default:
    break;
  }
  if (found == true)
  {
    EEPROM.commit();
    delay(100);
  }
}
String eeprom_read_string(int addr, int bufSize)
{
  char buffer[bufSize + 1];
  int bytesRead = 0;                       // number of bytes read so far
  byte ch = EEPROM.read(addr + bytesRead); // read next byte from eeprom
  buffer[bytesRead] = ch;                  // store it into the user buffer
  bytesRead++;                             // increment byte counter
                                           // stop conditions:
                                           // - the character just read is the string terminator one (0x00)
                                           // - we have filled the user buffer
  while ((ch != 0x00) && (bytesRead <= bufSize))
  {
    // if no stop condition is met, read the next byte from eeprom
    ch = EEPROM.read(addr + bytesRead);
    buffer[bytesRead] = ch; // store it into the user buffer
    bytesRead++;            // increment byte counter
  }
  // make sure the user buffer has a string terminator, (0x00) as its last byte
  if ((ch != 0x00) && (bytesRead >= 1))
  {
    buffer[bytesRead - 1] = 0;
  }
  return String(buffer);
}