
int pufState = -1;
void spiffInit()
{
  SPIFFS.begin();
  if (!SPIFFS.exists(F("/formatComplete.txt")))
  {
    Serial.println(F("Please wait 30 secs for SPIFFS to be formatted"));
    build_wwwStatus2(F("SPIFF formatting"));
    SPIFFS.format();
    Serial.println(F("Spiffs formatted"));
    File f = SPIFFS.open(F("/formatComplete.txt"), "w");
    if (!f)
    {
      Serial.println(F("file open failed"));
      build_wwwStatus2(F("SPIFF format failed"));
    }
    else
    {
      f.println(F("Format Complete"));
      build_wwwStatus2(F("SPIFF formatted"));
    }
  }
  else
  {
    Serial.println(F("SPIFFS is formatted. Moving along..."));
    build_wwwStatus2(F("SPIFF mounted"));
  }
  SPIFFS.info(fs_info);
}
int getLastState()
{ // 0 = OFF   // 1 = ON
  File f = SPIFFS.open(F("/status.txt"), "r");
  if (!f)
  {
    build_wwwStatus2(F("State read: cannot read status.txt"));
    return 0;
  }
  else
  {
    String line = "0";
    while (f.available())
    {
      line = f.readStringUntil('\n');
    }
    f.close();
    int state = line.toInt();
    if (state < 0 || state > 1)
    {
      state = 0;
      build_wwwStatus2("State read: bad value - off" + line);
    }
    else
    {
      if (state == 1)
      {
        build_wwwStatus2(F("State read: on"));
      }
      else
      {
        build_wwwStatus2(F("State read: off"));
      }
    }
    return state;
  }
}
void writeState(int state)
{
  if (state != pufState)
  {
    pufState = state;
    File f = SPIFFS.open(F("/status.txt"), "w");
    if (!f)
    {
      build_wwwStatus2(F("State save: cannot write status.txt"));
    }
    else
    {
      if (state == 1)
      {
        build_wwwStatus2(F("State saved: on"));
      }
      else
      {
        build_wwwStatus2(F("State saved: off"));
      }
      f.println(String(state));
      f.close();
    }
  }
}