void writeCCU(String url)
{
  HTTPClient httpCCU;
  httpCCU.begin(host_CCUIP, 8181, url);
  int httpCode = httpCCU.GET();
  String payload = httpCCU.getString();
  if (httpCode != 200)
  {
    build_wwwStatus2("CCU:" + String(httpCode) + "/" + payload);
  }
  httpCCU.end();
  delay(100);
  // Serial.println("Sent values to CuxD");
}

// Send values to CCU
void reportCCU(String setState)
{ // ON=1 OFF=0
  if (CCU_CuxD == 1)
  {
    String url = "http://" + String(host_CCUIP) + "/cuxd.exe?x=dom.GetObject(\"CUxD." + String(CCU_CuxDAdress) + ".SET_STATE\").State(" + setState + ")";
    writeCCU(url);
  }
}

void setCCU_Param()
{
  if (CCU_CuxD == 1)
  {
    String url = "http://" + String(host_CCUIP) + "/cuxd.exe?x=dom.GetObject(\"CUxD." + String(CCU_CuxDAdress) + ".CMD_SETS\").State("
                                                                                                                 "%22wget%20-q%20-O%20-%20%27http://" +
                 WiFi.localIP().toString() + "/OFF%27%22"
                                             ")";
    writeCCU(url);
  }
  if (CCU_CuxD == 1)
  {
    String url = "http://" + String(host_CCUIP) + "/cuxd.exe?x=dom.GetObject(\"CUxD." + String(CCU_CuxDAdress) + ".CMD_SETL\").State("
                                                                                                                 "%22wget%20-q%20-O%20-%20%27http://" +
                 WiFi.localIP().toString() + "/ON%27%22"
                                             ")";
    writeCCU(url);
  }
  if (CCU_CuxD == 0)
  {
    String url = "http://" + String(host_CCUIP) + "/cuxd.exe?x=dom.GetObject(\"CUxD." + String(CCU_CuxDAdress) + ".CMD_SETS\").State(%22%20%22)";
    writeCCU(url);
  }
  if (CCU_CuxD == 0)
  {
    String url = "http://" + String(host_CCUIP) + "/cuxd.exe?x=dom.GetObject(\"CUxD." + String(CCU_CuxDAdress) + ".CMD_SETL\").State(%22%20%22)";
    writeCCU(url);
  }
}

void handle_CCU()
{
  String CCU_IP = server.arg("ip");
  String CCUCUXD = server.arg("cuxd");
  String CCUCUXDDEVICE = server.arg("cuxdDevice");

  if (CCU_IP != "")
  {
    eeprom_Function = 12;
    CCU_IP.toCharArray(host_CCUIP, 16);
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "CCU IP : " + String(host_CCUIP) + wwwGoBack);
    delay(100);
    //Serial.println("CCU IP");
    writeEEPROM();
  }
  if (CCUCUXDDEVICE != "")
  {
    eeprom_Function = 11;
    CCUCUXDDEVICE.toCharArray(CCU_CuxDAdress, 38);
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "CCU CuxD device adress : " + String(CCU_CuxDAdress) + wwwGoBack);
    delay(100);
    //Serial.println("CCU CuxD Device");
    writeEEPROM();
  }
  else if (CCUCUXD != "")
  {
    eeprom_Function = 10;
    CCU_CuxD = CCUCUXD.toInt();
    if (CCU_CuxD < 0)
    {
      CCU_CuxD = 0;
    }
    if (CCU_CuxD > 1)
    {
      CCU_CuxD = 1;
    }
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "CCU CuxD Active : " + String(CCU_CuxD) + " " + String(CCU_CuxDAdress) + "-updated" + wwwGoBack);
    delay(100);
    //Serial.println("CCU CuxD Active");
    writeEEPROM();
    setCCU_Param();
  }
  else
  {
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "CCU nothing done" + wwwGoBack);
    delay(100);
    //Serial.println("CCU = Did nothing");
  }
}
