// Send values to ioBroker
void reportIOB(int state)
{
  if (IOB_active == 1)
  {
    if (state == 1)
    { //on
      IOB_State = "true";
      IOB_Message = timeStamp() + "_RELAY-ON";
    }
    else if (state == 0)
    { //off
      IOB_State = "false";
      IOB_Message = timeStamp() + "_RELAY-OFF";
    }
    // state -1 : take last
    HTTPClient http;
    String url = "/setBulk?" + String(IOB_Datapoint_Path) + "." + String(IOB_Datapoint_Sub) + "." + String(IOB_Datapoint_State) + "=" + IOB_State + "&" +
                 String(IOB_Datapoint_Path) + "." + String(IOB_Datapoint_Sub) + "." + String(IOB_Datapoint_Message) + "=" + String(IOB_Message) + "&prettyPrint";
    http.begin(host_ioBrokerIP, host_ioBrokerPORT, url);
    int httpCode = http.GET();
    String payload = http.getString();
    if (httpCode != 200)
    {
      build_wwwStatus2("ioBroker:" + String(httpCode) + "/" + payload);
    }
    http.end();
    delay(100);
    //    Serial.println("Sent values to iob");
  }
}

void handle_ioBroker()
{
  String ioBrokerIP = server.arg("ip");
  String ioBrokerPORT = server.arg("port");
  String ioBrokerActive = server.arg("active");
  String ioBrokerPath = server.arg("path");
  String ioBrokerSub = server.arg("sub");
  String ioBrokerState = server.arg("st");
  String ioBrokerMessage = server.arg("msg");
  String ioBrokerStateTime = server.arg("statetime");

  if (ioBrokerIP != "")
  {
    eeprom_Function = 1;
    ioBrokerIP.toCharArray(host_ioBrokerIP, 16);
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "ioBroker IP : " + String(host_ioBrokerIP) + wwwGoBack);
    delay(100);
    //Serial.println("ioBroker IP");
    writeEEPROM();
  }
  else if (ioBrokerPORT != "")
  {
    eeprom_Function = 2;
    host_ioBrokerPORT = ioBrokerPORT.toInt();
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "ioBroker Port : " + String(host_ioBrokerPORT) + wwwGoBack);
    delay(100);
    //Serial.println("ioBroker Port");
    writeEEPROM();
  }
  else if (ioBrokerActive != "")
  {
    eeprom_Function = 13;
    IOB_active = ioBrokerActive.toInt();
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "ioBroker Active : " + String(IOB_active) + wwwGoBack);
    delay(100);
    //Serial.println("ioBroker Active");
    writeEEPROM();
  }
  else if (ioBrokerPath != "")
  {
    eeprom_Function = 3;
    ioBrokerPath.toCharArray(IOB_Datapoint_Path, 80);
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "ioBroker Path : " + String(IOB_Datapoint_Path) + wwwGoBack);
    delay(100);
    //Serial.println("ioBroker Datapoint Path");
    writeEEPROM();
  }
  else if (ioBrokerSub != "")
  {
    eeprom_Function = 4;
    ioBrokerSub.toCharArray(IOB_Datapoint_Sub, 80);
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "ioBroker Sub : " + String(IOB_Datapoint_Sub) + wwwGoBack);
    delay(100);
    //Serial.println("ioBroker Datapoint Sub");
    writeEEPROM();
  }
  else if (ioBrokerState != "")
  {
    eeprom_Function = 5;
    ioBrokerState.toCharArray(IOB_Datapoint_State, 80);
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "ioBroker StateName : " + String(IOB_Datapoint_State) + wwwGoBack);
    delay(100);
    //Serial.println("ioBroker Datapoint StateName");
    writeEEPROM();
  }
  else if (ioBrokerMessage != "")
  {
    eeprom_Function = 6;
    ioBrokerMessage.toCharArray(IOB_Datapoint_Message, 80);
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "ioBroker MessageName : " + String(IOB_Datapoint_Message) + wwwGoBack);
    delay(100);
    //Serial.println("ioBroker Datapoint MessageName");
    writeEEPROM();
  }
  else if (ioBrokerStateTime != "")
  {
    eeprom_Function = 8;
    DeltaSendState = ioBrokerStateTime.toInt() * 1000;
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "ioBroker StateTime : " + String(ioBrokerStateTime) + wwwGoBack);
    delay(100);
    //Serial.println("ioBroker StateTime");
    writeEEPROM();
  }

  else
  {
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "ioBroker nothing done" + wwwGoBack);
    delay(100);
    //Serial.println("ioBroker = Did nothing");
  }
}
